<?php

  class mw_data_actions_logs extends mw_data{

    // ------------------------------------------------------------------------------------
    //                                                                               config
    //

    function get_actions_logs_config(){
      $env = $this->env();
      return array(
        "do_log" => $env->config("actions_logs_do_log") ? true : false,
        "default_log" => $env->config("actions_logs_default_log") ? true : false,
        "default_log_get" => $env->config("actions_logs_default_log_get") ? true : false,
        "default_log_post" => $env->config("actions_logs_default_log_post") ? true : false
      );
    }

    function set_actions_logs_config($params = array()){
      if(isset($params["do_log"])){
        if(!$this->set_config("actions_logs_do_log", $params["do_log"] ? 1 : 0)){
          return false;
        }
      }
      if(isset($params["default_log"])){
        if(!$this->set_config("actions_logs_default_log", $params["default_log"] ? 1 : 0)){
          return false;
        }
      }
      if(isset($params["default_log_get"])){
        if(!$this->set_config("actions_logs_default_log_get", $params["default_log_get"] ? 1 : 0)){
          return false;
        }
      }
      if(isset($params["default_log_post"])){
        if(!$this->set_config("actions_logs_default_log_post", $params["default_log_post"] ? 1 : 0)){
          return false;
        }
      }
      return true;
    }

    // ------------------------------------------------------------------------------------
    //                                                                              actions
    //

    function clear_logs_actions(){
      $sgbd = $this->sgbd();
      try{
        $sgbd->query("DELETE FROM #--logs_actions");
      }
      catch(Exception $e) { return false; }
      return true;
    }

    // ------------------------------------------------------------------------------------
    //                                                                                 logs
    //

    function add_action_log($params = array()){
      $env = $this->env();
      $sgbd = $this->sgbd();
      $log = array();
      $log["action"] = isset($params["action"]) ? $params["action"] : $env->etat("mod")."/".$env->etat("controlleur")."/".$env->etat("action");
      $user = $env->user();
      $log["login"] = isset($params["login"]) ? $params["login"] : ($user ? $user["login"] : "");
      $log["get"] = isset($params["get"]) ? $params["get"] : null;
      $log["post"] = isset($params["post"]) ? $params["post"] : null;
      $log["from_ip"] = isset($params["from_ip"]) ? $params["from_ip"] : (isset($_SERVER["REMOTE_ADDR"]) ? $_SERVER["REMOTE_ADDR"] : "");
      try{
        $sql =
         "INSERT INTO #--actions_logs(`action`, `date_log`, `login`, `from_ip`, `get`, `post`) VALUES("
        ."  ".$this->eq($log["action"])
        .", NOW()"
        .", ".$this->eq($log["login"])
        .", ".$this->eq($log["from_ip"])
        .", ".$this->eq($log["get"])
        .", ".$this->eq($log["post"])
        .")";
        $sgbd->query($sql);
      }
      catch(Exception $e){ return false; }
      return true;
    }

    function clear_actions_logs(){
      $sgbd = $this->sgbd();
      try{
        $sgbd->query("DELETE FROM #--actions_logs");
      }
      catch(Exception $e){ return false; }
      return true;
    }

  }

?>